//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Model } from 'mongoose';
import { Room, RoomDocument } from '../Room';
import { RoomService } from '../RoomService';
import { BaseController } from '@core/api/BaseController';
import { MEDICALPRACTICE_PERMISSIONS } from '@modules/medicalpractice/permissions';
import { Get, Post, Patch, Delete, QueryParams, UseBefore, Res, Body, Param, Session, Header } from 'routing-controllers';
import { authenticated, checkPermission, checkApiDisabled, checkResourceDisabled } from '@core/api/middleware';
import { ModelController } from '@core/api/decorators';

@ModelController('Room')
@UseBefore(checkApiDisabled(RoomBaseController))
export class RoomBaseController extends BaseController {
    protected model: Model<RoomDocument>;

    protected static readonly _objName: string = 'Room';
    protected static readonly _apiDisabled: boolean = false;
    protected static readonly _readable: boolean = false;
    protected static readonly _creatable: boolean = false;
    protected static readonly _updatable: boolean = false;
    protected static readonly _deletable: boolean = false;
    protected static readonly _permission = {
        read: undefined,
        create: undefined,
        update: undefined,
        delete: undefined,
    };
    protected static readonly _auth = {
        read: false,
        create: true,
        update: true,
        delete: true,
    };

    constructor(roomService: RoomService) {
        super(Room, roomService);
    }

    @Get('/')
    @UseBefore(checkResourceDisabled(RoomBaseController.readable))
    public async getAllRoom(@QueryParams() params) {
        return super.getAll(params);
    }

    @Get('/:id')
    @UseBefore(checkResourceDisabled(RoomBaseController.readable))
    public async getOneRoom(@Param('id') id: string, @QueryParams() params) {
        return await super.getOne(id, params);
    }

    @Post('/')
    @UseBefore(checkResourceDisabled(RoomBaseController.creatable))
    @UseBefore(authenticated)
    public async postRoom(@Session() session, @Body() body: any) {
        return super.post(body, session);
    }

    @Patch('/:id')
    @UseBefore(checkResourceDisabled(RoomBaseController.updatable))
    @UseBefore(authenticated)
    public async patchRoom(@Session() session, @Param('id') id: string, @QueryParams() params, @Body() body: any) {
        return super.patch(id, body, session, params);
    }

    @Delete('/:id')
    @UseBefore(checkResourceDisabled(RoomBaseController.deletable))
    @UseBefore(authenticated)
    public async deleteRoom(@Session() session, @Param('id') id: string) {
        return super.delete(session, id);
    }

    @Get('/meta/options')
    @UseBefore(authenticated)
    public async getMetaOptionsRoom(@QueryParams() query) {
        return await super.getMetaOptions(query);
    }

    @Get('/export/csv')
    @Header('Content-Type', 'text/csv')
    @UseBefore(checkResourceDisabled(RoomBaseController.readable))
    public async getCsvExportRoom(@Res() response, @QueryParams() query) {
        response.attachment(`${RoomBaseController._objName.toLowerCase()}.csv`);
        const data = await super.getExport('csv', query);
        return response.send(data);
    }

    @Get('/export/xlsx')
    @Header('Content-Type', 'application/vnd.ms-excel')
    @UseBefore(checkResourceDisabled(RoomBaseController.readable))
    public async getXlsxExportRoom(@Res() response, @QueryParams() query) {
        response.attachment(`${RoomBaseController._objName.toLowerCase()}.xlsx`);
        const data = await super.getExport('xlsx', query);
        return response.send(data);
    }

    @Get('/export/pdf')
    @Header('Content-Type', 'application/pdf')
    @UseBefore(checkResourceDisabled(RoomBaseController.readable))
    public async getPdfExportRoom(@Res() response, @QueryParams() query) {
        response.attachment(`${RoomBaseController._objName.toLowerCase()}.pdf`);
        const data = await super.getExport('pdf', query);
        return response.send(data);
    }
}
